Attribute VB_Name = "basMain"
'
'  UserBlaster allows an NT Server administrator to maintain user
'  accounts programmatically from an Access database. With UserBlaster
'  you can add/del a large numbers of user accounts from a single
'  database. Now you can backup your user accounts or move your user
'  accounts to another NT Server easily. No more trying to backup and
'  restore Registry Hives.
'
'  UserBlaster was designed for a Local NT Server running IIS, but
'  UserBlaster could be adapted to a NT Domain Server. UserBlaster
'  must be run on the NT Server using an Administrators account.
'
'  UserBlaster is hard coded to add all user accounts to the Local
'  Group "Users".
'
'  UserBlaster is a simple program. It does use a small dll for getting
'  the address of a Unicode string.
'
'  The VB source code included in this program is free to the general
'  public with the following constraints:
'
'  The author of this program accepts no responsibility for damages
'  resulting from the use of this product and makes no warranty or
'  representation, either express or implied, including but not limited
'  to, any implied warranty of merchantability or fitness for a particular
'  purpose. This software is provided "AS IS", and you, its user, assume
'  all risks when using it.
'
'  The following credits must be included in any copies of this Visual
'  Basic Module.
'
'  Author:
'     David E. Suffield
'     Eckler Software
'     dsuffiel@worldaccessnet.com
'     http://www.worldaccessnet.com/~dsuffiel/eckler.htm
'
'  Be sure to check out our WEB page for other shareware and freeware products!
'
Option Explicit

Declare Function adrOf Lib "cookie" (variable As Any) As Long
Declare Function NetUserAdd Lib "netapi32" (ByVal lpwszSeverName As Any, ByVal level As Long, lpBuf As Any, lpParm_err As Long) As Long
Declare Function NetUserDel Lib "netapi32" (ByVal lpwszSeverName As Any, lpwszUserName As Any) As Long
Declare Function NetGroupAddUser Lib "netapi32" (ByVal lpwszSeverName As Any, lpwszGroupName As Any, lpwszUserName As Any) As Long
Declare Function NetLocalGroupAddMembers Lib "netapi32" (ByVal lpwszSeverName As Any, lpwszLocalGroupName As Any, ByVal level As Long, lpBuf As Any, ByVal membercount As Long) As Long

Type USER_INFO_1
   usri1_name As Long         'pointer to unicode string
   usri1_password As Long     'pointer to unicode string
   usri1_password_age As Long
   usri1_priv As Long
   usri1_home_dir As Long   'pointer to unicode string
   usri1_comment As Long    'pointer to unicode string
   usri1_flags As Long
   usri1_script_path As Long   'pointer to unicode string
End Type

Type LOCALGROUP_MEMBERS_INFO_3
   lgrmi3_domainandname As Long         'pointer to unicode string
End Type

Global Const USER_PRIV_GUEST = 0
Global Const USER_PRIV_USER = 1
Global Const USER_PRIV_ADMIN = 2

Global Const UF_SCRIPT = &H1
Global Const UF_ACCOUNTDISABLE = &H2
Global Const UF_HOMEDIR_REQUIRED = &H8
Global Const UF_LOCKOUT = &H10
Global Const UF_PASSWD_NOTREQD = &H20
Global Const UF_PASSWD_CANT_CHANGE = &H40
Global Const UF_DONT_EXPIRE_PASSWD = &H10000

Global Const ERROR_ACCESS_DENIED = 5
Global Const NERR_Success = 0
Global Const NERR_BASE = 2100
Global Const NERR_UserExists = (NERR_BASE + 124) 'The user account already exists.
Global Const NERR_PasswordTooShort = (NERR_BASE + 145) 'The password is shorter than required.
Global Const NERR_UserNotFound = (NERR_BASE + 121)

Function sToA(des() As Integer, src As String) As Long
'Convert string to wide integer array. Same as a unicode string.
   Dim n As Integer, i As Integer
   
   n = Len(src)
   If (n = 0) Then
      des(0) = 0
      Exit Function
   End If
   
   For i = 0 To n - 1
      des(i) = AscW(Mid$(src, i + 1, 1))
   Next
   des(i) = 0

End Function

